Index: trunk/engines/engine.go
===================================================================
--- trunk/engines/engine.go	(revision 9)
+++ trunk/engines/engine.go	(revision 10)
@@ -6,5 +6,5 @@
 }
 
-type TranslationEngine interface {
+type Engine interface {
 	InternalName() string
 	DisplayName() string
Index: trunk/engines/google.go
===================================================================
--- trunk/engines/google.go	(revision 9)
+++ trunk/engines/google.go	(revision 10)
@@ -9,11 +9,11 @@
 )
 
-type GoogleTranslateEngine struct{}
+type GoogleTranslate struct{}
 
-func (_ *GoogleTranslateEngine) InternalName() string { return "google" }
+func (_ *GoogleTranslate) InternalName() string { return "google" }
 
-func (_ *GoogleTranslateEngine) DisplayName() string { return "Google" }
+func (_ *GoogleTranslate) DisplayName() string { return "Google" }
 
-func (_ *GoogleTranslateEngine) getLangs(type_ string) ([]Language, error) {
+func (_ *GoogleTranslate) getLangs(type_ string) ([]Language, error) {
 	var langsType string
 	switch type_ {
@@ -84,17 +84,17 @@
 }
 
-func (e *GoogleTranslateEngine) SourceLanguages() ([]Language, error) {
+func (e *GoogleTranslate) SourceLanguages() ([]Language, error) {
 	return e.getLangs("source")
 }
 
-func (e *GoogleTranslateEngine) TargetLanguages() ([]Language, error) {
+func (e *GoogleTranslate) TargetLanguages() ([]Language, error) {
 	return e.getLangs("target")
 }
 
-func (_ *GoogleTranslateEngine) SupportsAutodetect() bool { return true }
+func (_ *GoogleTranslate) SupportsAutodetect() bool { return true }
 
-func (_ *GoogleTranslateEngine) DetectLanguage(text string) (Language, error) { return Language{}, nil }
+func (_ *GoogleTranslate) DetectLanguage(text string) (Language, error) { return Language{}, nil }
 
-func (_ *GoogleTranslateEngine) Translate(text string, from Language, to Language) (TranslationResult, error) {
+func (_ *GoogleTranslate) Translate(text string, from Language, to Language) (TranslationResult, error) {
 	requestURL, err := url.Parse("https://translate.google.com/m")
 
Index: trunk/engines/iciba.go
===================================================================
--- trunk/engines/iciba.go	(revision 9)
+++ trunk/engines/iciba.go	(revision 10)
@@ -10,10 +10,10 @@
 )
 
-// ICIBAEngine is an engine that fetches data from https://www.iciba.com.
-type ICIBAEngine struct{}
-
-func (_ *ICIBAEngine) InternalName() string { return "iciba" }
-
-func (_ *ICIBAEngine) DisplayName() string { return "iCIBA" }
+// ICIBA is an engine that fetches data from https://www.iciba.com.
+type ICIBA struct{}
+
+func (_ *ICIBA) InternalName() string { return "iciba" }
+
+func (_ *ICIBA) DisplayName() string { return "iCIBA" }
 
 var icibaLanguages = []Language{
@@ -212,11 +212,11 @@
 }
 
-func (_ *ICIBAEngine) SourceLanguages() ([]Language, error) { return icibaLanguages, nil }
-
-func (_ *ICIBAEngine) TargetLanguages() ([]Language, error) { return icibaLanguages, nil }
-
-func (_ *ICIBAEngine) SupportsAutodetect() bool { return true }
-
-func (_ *ICIBAEngine) DetectLanguage(text string) (Language, error) { return Language{}, nil }
+func (_ *ICIBA) SourceLanguages() ([]Language, error) { return icibaLanguages, nil }
+
+func (_ *ICIBA) TargetLanguages() ([]Language, error) { return icibaLanguages, nil }
+
+func (_ *ICIBA) SupportsAutodetect() bool { return true }
+
+func (_ *ICIBA) DetectLanguage(text string) (Language, error) { return Language{}, nil }
 
 type icibaTranslateResponse struct {
@@ -227,5 +227,5 @@
 }
 
-func (_ *ICIBAEngine) Translate(text string, from Language, to Language) (TranslationResult, error) {
+func (_ *ICIBA) Translate(text string, from Language, to Language) (TranslationResult, error) {
 	requestURL, err := url.Parse("https://ifanyi.iciba.com/index.php")
 
Index: trunk/engines/libretranslate.go
===================================================================
--- trunk/engines/libretranslate.go	(revision 9)
+++ trunk/engines/libretranslate.go	(revision 10)
@@ -8,7 +8,7 @@
 )
 
-// LibreTranslateEngine is an engine that interfaces with any
+// LibreTranslate is an engine that interfaces with any
 // [LibreTranslate](https://github.com/LibreTranslate/LibreTranslate) instance.
-type LibreTranslateEngine struct {
+type LibreTranslate struct {
 	// InstanceURL is the URL to a LibreTranslate instance, for instance
 	// "https://libretranslate.com".
@@ -24,7 +24,7 @@
 }
 
-func (_ *LibreTranslateEngine) InternalName() string { return "libre" }
+func (_ *LibreTranslate) InternalName() string { return "libre" }
 
-func (_ *LibreTranslateEngine) DisplayName() string { return "LibreTranslate" }
+func (_ *LibreTranslate) DisplayName() string { return "LibreTranslate" }
 
 type libreLanguagesResponse []struct {
@@ -33,5 +33,5 @@
 }
 
-func (e *LibreTranslateEngine) getLangs() ([]Language, error) {
+func (e *LibreTranslate) getLangs() ([]Language, error) {
 	response, err := http.Get(e.InstanceURL + "/languages")
 
@@ -62,9 +62,9 @@
 }
 
-func (e *LibreTranslateEngine) SourceLanguages() ([]Language, error) { return e.getLangs() }
+func (e *LibreTranslate) SourceLanguages() ([]Language, error) { return e.getLangs() }
 
-func (e *LibreTranslateEngine) TargetLanguages() ([]Language, error) { return e.getLangs() }
+func (e *LibreTranslate) TargetLanguages() ([]Language, error) { return e.getLangs() }
 
-func (_ *LibreTranslateEngine) SupportsAutodetect() bool { return true }
+func (_ *LibreTranslate) SupportsAutodetect() bool { return true }
 
 type libreDetectResponse []struct {
@@ -73,5 +73,5 @@
 }
 
-func (e *LibreTranslateEngine) DetectLanguage(text string) (Language, error) {
+func (e *LibreTranslate) DetectLanguage(text string) (Language, error) {
 	formData := map[string]string{"q": text}
 
@@ -131,5 +131,5 @@
 }
 
-func (e *LibreTranslateEngine) Translate(text string, from Language, to Language) (TranslationResult, error) {
+func (e *LibreTranslate) Translate(text string, from Language, to Language) (TranslationResult, error) {
 	formData := map[string]string{
 		"q":      text,